osgSim::LightPointNode Class Reference

`#include <LightPointNode>`

Inheritance diagram for osgSim::LightPointNode:

## Public Types

typedef std::vector< LightPoint > | LightPointList
Public Types inherited from osg::Node
typedef std::vector< Group * > | ParentList
typedef unsigned int | NodeMask
typedef std::vector< std::string > | DescriptionList
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| LightPointNode ()
| LightPointNode (const LightPointNode &, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Node (osgSim, LightPointNode)
virtual void | traverse (osg::NodeVisitor &nv)
unsigned int | getNumLightPoints () const
unsigned int | addLightPoint (const LightPoint &lp)
void | removeLightPoint (unsigned int pos)
LightPoint & | getLightPoint (unsigned int pos)
const LightPoint & | getLightPoint (unsigned int pos) const
void | setLightPointList (const LightPointList &lpl)
LightPointList & | getLightPointList ()
const LightPointList & | getLightPointList () const
void | setMinPixelSize (float minPixelSize)
float | getMinPixelSize () const
void | setMaxPixelSize (float maxPixelSize)
float | getMaxPixelSize () const
void | setMaxVisibleDistance2 (float maxVisibleDistance2)
float | getMaxVisibleDistance2 () const
void | setLightPointSystem (osgSim::LightPointSystem *lps)
osgSim::LightPointSystem * | getLightPointSystem ()
const osgSim::LightPointSystem * | getLightPointSystem () const
void | setPointSprite (bool enable=true)
bool | getPointSprite () const
virtual osg::BoundingSphere | computeBound () const
Public Member Functions inherited from osg::Node
| Node ()
| Node (const Node &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const
virtual Object * | clone (const CopyOp &copyop) const
virtual bool | isSameKindAs (const Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Geometry * | asGeometry ()
virtual const Geometry * | asGeometry () const
virtual Group * | asGroup ()
virtual const Group * | asGroup () const
virtual Transform * | asTransform ()
virtual const Transform * | asTransform () const
virtual Switch * | asSwitch ()
virtual const Switch * | asSwitch () const
virtual Geode * | asGeode ()
virtual const Geode * | asGeode () const
virtual osgTerrain::Terrain * | asTerrain ()
virtual const osgTerrain::Terrain * | asTerrain () const
virtual void | accept (NodeVisitor &nv)
virtual void | ascend (NodeVisitor &nv)
const ParentList & | getParents () const
ParentList | getParents ()
Group * | getParent (unsigned int i)
const Group * | getParent (unsigned int i) const
unsigned int | getNumParents () const
NodePathList | getParentalNodePaths (osg::Node *haltTraversalAtNode=0) const
MatrixList | getWorldMatrices (const osg::Node *haltTraversalAtNode=0) const
void | setUpdateCallback (Callback *nc)
template<class T>
void | setUpdateCallback (const ref_ptr< T > &nc)
Callback * | getUpdateCallback ()
const Callback * | getUpdateCallback () const
void | addUpdateCallback (Callback *nc)
template<class T>
void | addUpdateCallback (const ref_ptr< T > &nc)
void | removeUpdateCallback (Callback *nc)
template<class T>
void | removeUpdateCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringUpdateTraversal () const
void | setEventCallback (Callback *nc)
template<class T>
void | setEventCallback (const ref_ptr< T > &nc)
Callback * | getEventCallback ()
const Callback * | getEventCallback () const
void | addEventCallback (Callback *nc)
template<class T>
void | addEventCallback (const ref_ptr< T > &nc)
void | removeEventCallback (Callback *nc)
template<class T>
void | removeEventCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringEventTraversal () const
void | setCullCallback (Callback *nc)
template<class T>
void | setCullCallback (const ref_ptr< T > &nc)
Callback * | getCullCallback ()
const Callback * | getCullCallback () const
void | addCullCallback (Callback *nc)
template<class T>
void | addCullCallback (const ref_ptr< T > &nc)
void | removeCullCallback (Callback *nc)
template<class T>
void | removeCullCallback (const ref_ptr< T > &nc)
void | setCullingActive (bool active)
bool | getCullingActive () const
unsigned int | getNumChildrenWithCullingDisabled () const
bool | isCullingActive () const
unsigned int | getNumChildrenWithOccluderNodes () const
bool | containsOccluderNodes () const
void | setNodeMask (NodeMask nm)
NodeMask | getNodeMask () const
void | setStateSet (osg::StateSet *stateset)
template<class T>
void | setStateSet (const osg::ref_ptr< T > &stateset)
osg::StateSet * | getOrCreateStateSet ()
osg::StateSet * | getStateSet ()
const osg::StateSet * | getStateSet () const
void | setDescriptions (const DescriptionList &descriptions)
DescriptionList & | getDescriptions ()
const DescriptionList & | getDescriptions () const
const std::string & | getDescription (unsigned int i) const
std::string & | getDescription (unsigned int i)
unsigned int | getNumDescriptions () const
void | addDescription (const std::string &desc)
void | setInitialBound (const osg::BoundingSphere &bsphere)
const BoundingSphere & | getInitialBound () const
void | dirtyBound ()
const BoundingSphere & | getBound () const
void | setComputeBoundingSphereCallback (ComputeBoundingSphereCallback *callback)
template<class T>
void | setComputeBoundingSphereCallback (const ref_ptr< T > &callback)
ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback ()
const ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

| ~LightPointNode ()
Protected Member Functions inherited from osg::Node
virtual | ~Node ()
void | addParent (osg::Group *parent)
void | removeParent (osg::Group *parent)
void | setNumChildrenRequiringUpdateTraversal (unsigned int num)
void | setNumChildrenRequiringEventTraversal (unsigned int num)
void | setNumChildrenWithCullingDisabled (unsigned int num)
void | setNumChildrenWithOccluderNodes (unsigned int num)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

osg::BoundingBox | _bbox
LightPointList | _lightPointList
float | _minPixelSize
float | _maxPixelSize
float | _maxVisibleDistance2
osg::ref_ptr< osgSim::LightPointSystem > | _lightSystem
bool | _pointSprites
Protected Attributes inherited from osg::Node
BoundingSphere | _initialBound
ref_ptr< ComputeBoundingSphereCallback > | _computeBoundCallback
BoundingSphere | _boundingSphere
bool | _boundingSphereComputed
ParentList | _parents
ref_ptr< Callback > | _updateCallback
unsigned int | _numChildrenRequiringUpdateTraversal
ref_ptr< Callback > | _eventCallback
unsigned int | _numChildrenRequiringEventTraversal
ref_ptr< Callback > | _cullCallback
bool | _cullingActive
unsigned int | _numChildrenWithCullingDisabled
unsigned int | _numChildrenWithOccluderNodes
NodeMask | _nodeMask
ref_ptr< StateSet > | _stateset
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Member Typedef Documentation

## LightPointList

typedef std::vector< LightPoint > osgSim::LightPointNode::LightPointList

## Constructor & Destructor Documentation

## LightPointNode() [1/2]

osgSim::LightPointNode::LightPointNode | ( |  | ) |

Referenced by LightPointNode(), and META_Node().

## LightPointNode() [2/2]

osgSim::LightPointNode::LightPointNode | ( | const LightPointNode & | ,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

Copy constructor using CopyOp to manage deep vs shallow copy.

References LightPointNode(), and osg::CopyOp::SHALLOW_COPY.

## ~LightPointNode()

osgSim::LightPointNode::~LightPointNode | ( |  | ) |

inline protected

## Member Function Documentation

## addLightPoint()

unsigned int osgSim::LightPointNode::addLightPoint | ( | const LightPoint & | lp | ) |

## computeBound()

virtual osg::BoundingSphere osgSim::LightPointNode::computeBound | ( |  | ) | const

virtual

Compute the bounding sphere around Node's geometry or children. This method is automatically called by getBound() when the bounding sphere has been marked dirty via dirtyBound().

Reimplemented from osg::Node.

## getLightPoint() [1/2]

LightPoint & osgSim::LightPointNode::getLightPoint | ( | unsigned int | pos | ) |

inline

References _lightPointList.

## getLightPoint() [2/2]

const LightPoint & osgSim::LightPointNode::getLightPoint | ( | unsigned int | pos | ) | const

inline

References _lightPointList.

## getLightPointList() [1/2]

LightPointList & osgSim::LightPointNode::getLightPointList | ( |  | ) |

inline

References _lightPointList.

## getLightPointList() [2/2]

const LightPointList & osgSim::LightPointNode::getLightPointList | ( |  | ) | const

inline

References _lightPointList.

## getLightPointSystem() [1/2]

osgSim::LightPointSystem * osgSim::LightPointNode::getLightPointSystem | ( |  | ) |

inline

References _lightSystem.

## getLightPointSystem() [2/2]

const osgSim::LightPointSystem * osgSim::LightPointNode::getLightPointSystem | ( |  | ) | const

inline

References _lightSystem.

## getMaxPixelSize()

float osgSim::LightPointNode::getMaxPixelSize | ( |  | ) | const

inline

References _maxPixelSize.

## getMaxVisibleDistance2()

float osgSim::LightPointNode::getMaxVisibleDistance2 | ( |  | ) | const

inline

References _maxVisibleDistance2.

## getMinPixelSize()

float osgSim::LightPointNode::getMinPixelSize | ( |  | ) | const

inline

References _minPixelSize.

## getNumLightPoints()

unsigned int osgSim::LightPointNode::getNumLightPoints | ( |  | ) | const

inline

References _lightPointList.

## getPointSprite()

bool osgSim::LightPointNode::getPointSprite | ( |  | ) | const

inline

References _pointSprites.

## META_Node()

osgSim::LightPointNode::META_Node | ( | osgSim | ,
|  | LightPointNode | )

References LightPointNode().

## removeLightPoint()

void osgSim::LightPointNode::removeLightPoint | ( | unsigned int | pos | ) |

## setLightPointList()

void osgSim::LightPointNode::setLightPointList | ( | const LightPointList & | lpl | ) |

inline

References _lightPointList.

## setLightPointSystem()

void osgSim::LightPointNode::setLightPointSystem | ( | osgSim::LightPointSystem * | lps | ) |

inline

References _lightSystem.

## setMaxPixelSize()

void osgSim::LightPointNode::setMaxPixelSize | ( | float | maxPixelSize | ) |

inline

References _maxPixelSize.

## setMaxVisibleDistance2()

void osgSim::LightPointNode::setMaxVisibleDistance2 | ( | float | maxVisibleDistance2 | ) |

inline

References _maxVisibleDistance2.

## setMinPixelSize()

void osgSim::LightPointNode::setMinPixelSize | ( | float | minPixelSize | ) |

inline

References _minPixelSize.

## setPointSprite()

void osgSim::LightPointNode::setPointSprite | ( | bool | enable = true | ) |

inline

References _pointSprites.

## traverse()

virtual void osgSim::LightPointNode::traverse | ( | osg::NodeVisitor & |  | ) |

virtual

Traverse downwards : calls children's accept method with NodeVisitor.

Reimplemented from osg::Node.

## Member Data Documentation

## _bbox

osg::BoundingBox osgSim::LightPointNode::_bbox

mutable protected

## _lightPointList

LightPointList osgSim::LightPointNode::_lightPointList

protected

Referenced by getLightPoint(), getLightPoint(), getLightPointList(), getLightPointList(), getNumLightPoints(), and setLightPointList().

## _lightSystem

osg::ref_ptr<osgSim::LightPointSystem> osgSim::LightPointNode::_lightSystem

protected

Referenced by getLightPointSystem(), getLightPointSystem(), and setLightPointSystem().

## _maxPixelSize

float osgSim::LightPointNode::_maxPixelSize

protected

Referenced by getMaxPixelSize(), and setMaxPixelSize().

## _maxVisibleDistance2

float osgSim::LightPointNode::_maxVisibleDistance2

protected

Referenced by getMaxVisibleDistance2(), and setMaxVisibleDistance2().

## _minPixelSize

float osgSim::LightPointNode::_minPixelSize

protected

Referenced by getMinPixelSize(), and setMinPixelSize().

## _pointSprites

bool osgSim::LightPointNode::_pointSprites

protected

Referenced by getPointSprite(), and setPointSprite().

The documentation for this class was generated from the following file:

- LightPointNode